Status: Resolved Priority: Should have
Author: Robert Lemke Category: Object
Updated: 2012-02-07 Due date:

Sprint:

PHP Version: 53

Has patch: No

Complexity: easy

Subject: Issue warning / error when trying to @inject into private property

Description

Class properties declared as private cannot be used for property injection by using the @FLOWB3\Inject annotation because the proxy
class can only set it in its own scope. If private properties are really necessary, constructor or setter injection can be used as a

workaround.

FLOWS should throw an exception on detecting an inject annotation on a private property.

Associated revisions

Revision 837fc980 - 2012-02-06 21:30 - Adrian Foder

[TASK] Throw exception when private properties have @Inject

Properties annotated for injection do obviously have to
be at least protected in order for the proxy class

having access to it.

This patch makes an exception thrown when such private

properties occur.
Change-Id: 194c3bd81ee7242ccc341e657€9088877ada19103

Resolves: #33589

Releases: 1.1

History

#1 - 2012-02-01 15:08 - Robert Lemke

Hint: the exception should be thrown in the ConfigurationBuilder:

foreach ($this->reflectionService->getPropertyNamesByTag($className, 'inject’) as $propertyName) {

if (larray_key_exists($propertyName, $properties)) {

$objectName = trim(implode(", $this->reflectionService->getPropertyTagValues($className, $propertyName, 'var')), ' \\');

$properties[$propertyName] = new ConfigurationProperty($propertyName, $objectName,

ConfigurationProperty::PROPERTY_TYPES_OBJECT);
}

#2 - 2012-02-01 15:10 - Adrian Foéder
- Status changed from New to Accepted

- Assigned To set to Adrian Foder
#3 - 2012-02-01 16:57 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/8794

#4 - 2012-02-01 16:58 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/8794

#5 - 2012-02-01 17:15 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.0rg/8794

#6 - 2012-02-06 21:29 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/8794

#7 - 2012-02-07 02:46 - Adrian Foder
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:837fc9800a6530274df2b2d575afdc20c24280f0.
